| IGLib 1.6.0 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Events
Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Attributes | Properties | List of all members
IG.Num.InputOutputDataDefiniton Class Reference

Definition of input and output data for vector functions, approximations, etc. Contains descriptiove information about individual eleemnts of input and output, default values and eventual bounds of input parameters, etc. More...

## Public Member Functions
| InputOutputDataDefiniton ()
virtual InputElementDefinition | GetInputElement (int which)
| Returns the specified input element definition. More...
virtual void | SetInputElement (int which, InputElementDefinition element)
| Sets the input element definition with the specified index to the specified object. More...
virtual void | AddInputElement (InputElementDefinition element)
| Adds the specified input element definition to the list of input element definitions. More...
virtual int | GetInputIndex (string inputName)
| Gets index of the input element that has the specified name, or -1 if there is no such input element. More...
virtual int | GetInputIndexByNameAlt (string inputNameAlt)
| Gets index of the input element that has the specified alternative name, or -1 if there is no such input element. More...
virtual int | GetInputIndexByNameOrNameAlt (string inputNameOrNameAlt)
| Gets index of the input element that has the specified name or alternative name, or -1 if there is no such input element. More...
virtual OutputElementDefinition | GetOutputElement (int which)
virtual void | SetOutputElement (int which, OutputElementDefinition element)
| Sets the output element definition with the specified index to the specified object. More...
virtual void | AddOutputElement (OutputElementDefinition element)
| Adds the specified output element definition to the list of output element definitionss. More...
virtual int | GetOutputIndex (string outputName)
| Gets index of the output element that has the specified name, or -1 if there is no such output element. More...
virtual int | GetOutputIndexByNameAlt (string outputNameAlt)
| Gets index of the output element that has the specified alternative name, or -1 if there is no such output element. More...
virtual int | GetOutputIndexByNameOrNameAlt (string outputNameOrNameAlt)
| Gets index of the output element that has the specified name or alternative name, or -1 if there is no such output element. More...
virtual void | CopyDefaultInputFrom (IVector inputParameters)
| Copies input parameters from the specified vector to the current data definition's default input values. More...
virtual void | CopyDefaultInputTo (ref IVector inputParameters)
| Stores default values of input parameters from the current data definition in the specified vector. More...
virtual void | GetInputBounds (ref IBoundingBox bounds)
| Extracts input bounds as defined on the current data definition object, and stores them in the specified bounding box. More...
virtual void | GetOutputBounds (ref IBoundingBox bounds)
| Extracts output bounds as defined on the current data definition object, and stores them in the specified bounding box. More...
virtual bool | IsAnyInputNameDefined ()
| Returns a value indicating whether any input element has Name property defined. More...
virtual bool | IsAnyOutputNameDefined ()
| Returns a value indicating whether any output element has Name property defined. More...
virtual bool | IsAnyNameDefined ()
| Returns a value indicating whether any element (either input or output) has Name property defined. More...
virtual bool | IsAnyInputTitleDefined ()
| Returns a value indicating whether any input element has Title property defined. More...
virtual bool | IsAnyOutputTitleDefined ()
| Returns a value indicating whether any output element has Title property defined. More...
virtual bool | IsAnyTitleDefined ()
| Returns a value indicating whether any element (either input or output) has Title property defined. More...
virtual bool | IsAnyInputDescriptionDefined ()
| Returns a value indicating whether any input element has Description property defined. More...
virtual bool | IsAnyOutputDescriptionDefined ()
| Returns a value indicating whether any output element has Description property defined. More...
virtual bool | IsAnyDescriptionDefined ()
| Returns a value indicating whether any element (either input or output) has Description property defined. More...
virtual bool | IsAnyInputDiscretizationStepDefined ()
| Returns a value indicating whether any input element has DiscretizationStep property defined. More...
virtual bool | IsAnyOutputDiscretizationStepDefined ()
| Returns a value indicating whether any output element has DiscretizationStep property defined. More...
virtual bool | IsAnyDiscretizationStepDefined ()
| Returns a value indicating whether any element (either input or output) has DiscretizationStep property defined. More...
virtual bool | IsAnyInputBoundDefined ()
| Returns a value indicating whether any input element has bounds defined. More...
virtual bool | IsAnyOutputBoundDefined ()
| Returns a value indicating whether any output element has bounds defined. More...
virtual bool | IsAnyBoundDefined ()
| Returns a value indicating whether any element (either input or output) has bounds defined. More...
virtual bool | IsAnyInputScalingLengthDefined ()
| Returns a value indicating whether any input element has scaling length defined. More...
virtual bool | IsAnyOutputScalingLengthDefined ()
| Returns a value indicating whether any output element has scaling length defined. More...
virtual bool | IsAnyScalingLengthDefined ()
| Returns a value indicating whether any element (either input or output) has scaling length defined. More...
virtual bool | IsAnyInputTargetValueDefined ()
| Returns a value indicating whether any input element has target value defined. More...
virtual bool | IsAnyOutputTargetValueDefined ()
| Returns a value indicating whether any output element has target value defined. More...
virtual bool | IsAnyTargetValueDefined ()
| Returns a value indicating whether any element (either input or output) has target value defined. More...
virtual bool | IsAnyInputDefaultValueDefined ()
| Returns a value indicating whether any input element has default value defined. More...
virtual bool | IsAnyOutputDefaultValueDefined ()
| Returns a value indicating whether any output element has default value defined. More...
virtual bool | IsAnyDefaultValueDefined ()
| Returns a value indicating whether any element (either input or output) has default value defined. More...
virtual bool | IsAnyInputElementIndexSpecified ()
| Returns a value indicating whether any input element has element index specified. More...
virtual bool | IsAnyOutputElementIndexSpecified ()
| Returns a value indicating whether any output element has element index specified. More...
virtual bool | IsAnyElementIndexSpecified ()
| Returns a value indicating whether any element (either input or output) has element index specified. More...
virtual bool | IsAnyInputOptimizationIndexSpecified ()
| Returns a value indicating whether any input element has element index specified. More...
virtual bool | IsAnyOutputOptimizationIndexSpecified ()
| Returns a value indicating whether any output element has element index specified. More...
virtual bool | IsAnyOptimizationIndexSpecified ()
| Returns a value indicating whether any element (either input or output) has element index specified. More...
override string | ToString ()
| Returns string representation of the current object. More...

## Static Public Member Functions
static void | SaveJson (InputOutputDataDefiniton dataDef, string filePath)
| Saves input/output data definition to the specified JSON file. File is owerwritten if it exists. More...
static void | LoadJson (string filePath, ref InputOutputDataDefiniton dataDefRestored)
| Restores input/output data definition from the specified file in JSON format. More...
static InputOutputDataDefiniton | CreateDefault (int inputLength, int outputLength)
| Creates and returns a data definition with fields set to default values. More...
static void | SupplementDataDefinition (InputOutputDataDefiniton data, SampledDataSet trainingData)
| Suplements the specified data definition object with information that is extracted from the training data set. Some data is updated independently of the training data set, and this data is updated even if the training data set is not specified. If bounds on input parameters and output values are not defined then bounds are set to bounds within which training data fits. If default values and target values are not specified then these values are set to centers of intervals. If names, titles and descriptions are not specified (null or empty string) then default strings are provided. If optimization parameter indices are not specified for input parameters then these indices are taken the same as elementindices. For fields that have the corresponding "...Defined" flag, data is recalculated only if that flag is set to false. In order to ensure recalculation of such fields, set the corresponding flags to false (for example, BoundsDefined for MinimalValue and MaximalValue, ScalingLengthDefined for ScalingLength, TargetValueDefined for TargetValue, etc.). More...
static void | SupplementDataDefinition (string dataDefinitionPath, string trainingDataPath)
| Suplements the specified data definition object with information that is extracted from the training data set and with automatically generated information. More...
static void | SupplementDataDefinition (string dataDefinitionPath, string trainingDataPath, string updatedDataDefinitionPath)
| Suplements the specified data definition object with information that is extracted from the training data set and with automatically generated information. More...
static void | CopyPlain (InputOutputDataDefiniton original, InputOutputDataDefiniton copy)
| Copies data from one data definition to another. More...
static void | Copy (InputOutputDataDefiniton original, ref InputOutputDataDefiniton copy)
| Copies data from one data definition to another. More...
static InputOutputDataDefiniton | CreateExample (int inputLength, int outputLength)
| Creates and returns an example data definition. More...

## Static Public Attributes
static string | DefaultName = null
| Default value of the Name property of the input and output data definitions. More...
static string | DefaultDescription = null
| Default value of the Description property of the input and output data definitions. More...

## Protected Attributes
string | _name = DefaultName
string | _description = DefaultDescription
List< InputElementDefinition > | _input = new List<InputElementDefinition>()
List< OutputElementDefinition > | _output = new List<OutputElementDefinition>()

## Properties
string | Name`[get, set]`
| Name of the current definition of input parameters and output values of a model. More...
string | Description`[get, set]`
| Description of the current definition of input parameters and output values of a model. More...
int | InputLength`[get]`
| Gets number of input parameters. More...
int | OutputLength`[get]`
| Gets number of output values. More...
virtual List < InputElementDefinition > | InputElementList`[get]`
virtual List < OutputElementDefinition > | OutputElementList`[get]`

## Detailed Description

Definition of input and output data for vector functions, approximations, etc. Contains descriptiove information about individual eleemnts of input and output, default values and eventual bounds of input parameters, etc.

$A Igor Mar11;

## Constructor & Destructor Documentation

IG.Num.InputOutputDataDefiniton.InputOutputDataDefiniton | ( |  | ) |
| inline

## Member Function Documentation

virtual InputElementDefinition IG.Num.InputOutputDataDefiniton.GetInputElement | ( | int | which | ) |
| inline virtual

Returns the specified input element definition.

Parameters

  which | Specifies which input element definition is returned.

Referenced by IG.Num.InputOutputDataDefiniton.CopyPlain(), IG.Neural.MappingDefinition.IsInputDataConsistent(), IG.Neural.NeuralTadej.SaveDefinitionDataCSV(), IG.Num.SampledDataSet.SaveDefinitionDataCSV(), IG.Num.SampledDataSet.SaveSampledDataCSV(), IG.Num.SampledDataSet.SaveSampledDataCSVinOneLine(), IG.Neural.NeuralTadej.SaveTrainingDataCSV(), IG.Neural.NeuralTadej.SaveTrainingDataCSVinOneLine(), and IG.Num.InputOutputDataDefiniton.SupplementDataDefinition().

virtual void IG.Num.InputOutputDataDefiniton.SetInputElement | ( | int | which,
|  | InputElementDefinition | element
| ) |  |
| inline virtual

Sets the input element definition with the specified index to the specified object.

Parameters

  which | Index of input element definition.
  element | Imput element definition object to which the specified input element definition is set.

Exceptions

  IndexOutOfRangeException | When index is out of range.

virtual void IG.Num.InputOutputDataDefiniton.AddInputElement | ( | InputElementDefinition | element | ) |
| inline virtual

Adds the specified input element definition to the list of input element definitions.

Parameters

  element | Input element to be added.

Referenced by IG.Num.InputOutputDataDefiniton.CopyPlain(), IG.Num.InputOutputDataDefiniton.CreateDefault(), and IG.Num.InputOutputDataDefiniton.CreateExample().

virtual int IG.Num.InputOutputDataDefiniton.GetInputIndex | ( | string | inputName | ) |
| inline virtual

Gets index of the input element that has the specified name, or -1 if there is no such input element.

Parameters

  inputName | Name of the input element whose index is to be returned.

This method is slow when the number of elements is large, becase it iterates through all elements before the matching element is found. If necessary, indexing can be introduce later in order to achieve improvement.

virtual int IG.Num.InputOutputDataDefiniton.GetInputIndexByNameAlt | ( | string | inputNameAlt | ) |
| inline virtual

Gets index of the input element that has the specified alternative name, or -1 if there is no such input element.

Parameters

  inputNameAlt | Slternative name of the input element whose index is to be returned.

This method is slow when the number of elements is large, becase it iterates through all elements before the matching element is found. If necessary, indexing can be introduce later in order to achieve improvement.

virtual int IG.Num.InputOutputDataDefiniton.GetInputIndexByNameOrNameAlt | ( | string | inputNameOrNameAlt | ) |
| inline virtual

Gets index of the input element that has the specified name or alternative name, or -1 if there is no such input element.

Parameters

  inputNameOrNameAlt | Slternative name of the input element whose index is to be returned.

This method is slow when the number of elements is large, becase it iterates through all elements before the matching element is found. If necessary, indexing can be introduced later in order to achieve improvement.

virtual OutputElementDefinition IG.Num.InputOutputDataDefiniton.GetOutputElement | ( | int | which | ) |
| inline virtual

Referenced by IG.Num.InputOutputDataDefiniton.CopyPlain(), IG.Neural.MappingDefinition.IsOutputDataConsistent(), IG.Num.SampledDataSet.SaveSampledDataCSV(), IG.Num.SampledDataSet.SaveSampledDataCSVinOneLine(), IG.Neural.NeuralTadej.SaveTrainingDataCSV(), IG.Neural.NeuralTadej.SaveTrainingDataCSVinOneLine(), and IG.Num.InputOutputDataDefiniton.SupplementDataDefinition().

virtual void IG.Num.InputOutputDataDefiniton.SetOutputElement | ( | int | which,
|  | OutputElementDefinition | element
| ) |  |
| inline virtual

Sets the output element definition with the specified index to the specified object.

Parameters

  which | Index of output element definition.
  element | Output element definition object to which the specified output element definition is set.

Exceptions

  IndexOutOfRangeException | When index is out of range.

virtual void IG.Num.InputOutputDataDefiniton.AddOutputElement | ( | OutputElementDefinition | element | ) |
| inline virtual

Adds the specified output element definition to the list of output element definitionss.

Parameters

  element | Output element to be added.

Referenced by IG.Num.InputOutputDataDefiniton.CopyPlain(), IG.Num.InputOutputDataDefiniton.CreateDefault(), and IG.Num.InputOutputDataDefiniton.CreateExample().

virtual int IG.Num.InputOutputDataDefiniton.GetOutputIndex | ( | string | outputName | ) |
| inline virtual

Gets index of the output element that has the specified name, or -1 if there is no such output element.

Parameters

  outputName | Name of the output element whose index is to be returned.

This method is slow when the number of elements is large, becase it iterates through all elements before the matching element is found. If necessary, indexing can be introduce later in order to achieve improvement.

virtual int IG.Num.InputOutputDataDefiniton.GetOutputIndexByNameAlt | ( | string | outputNameAlt | ) |
| inline virtual

Gets index of the output element that has the specified alternative name, or -1 if there is no such output element.

Parameters

  outputNameAlt | Alternative name of the output element whose index is to be returned.

This method is slow when the number of elements is large, becase it iterates through all elements before the matching element is found. If necessary, indexing can be introduce later in order to achieve improvement.

virtual int IG.Num.InputOutputDataDefiniton.GetOutputIndexByNameOrNameAlt | ( | string | outputNameOrNameAlt | ) |
| inline virtual

Gets index of the output element that has the specified name or alternative name, or -1 if there is no such output element.

Parameters

  outputNameOrNameAlt | Name or alternative name of the output element whose index is to be returned.

This method is slow when the number of elements is large, becase it iterates through all elements before the matching element is found. If necessary, indexing can be introduced later in order to achieve improvement.

virtual void IG.Num.InputOutputDataDefiniton.CopyDefaultInputFrom | ( | IVector | inputParameters | ) |
| inline virtual

Copies input parameters from the specified vector to the current data definition's default input values.

The default value flag is set on every element.

Parameters

  inputParameters | Vector from which default input values are copied.

Exceptions

  ArgumentException | If inputParameters is null or of incorrect dimension.

References IG.Num.InputElementDefinition.DefaultValue, and IG.Num.InputElementDefinition.DefaultValueDefined.

virtual void IG.Num.InputOutputDataDefiniton.CopyDefaultInputTo | ( | ref IVector | inputParameters | ) |
| inline virtual

Stores default values of input parameters from the current data definition in the specified vector.

Vector is resized if necessary.

Parameters

  inputParameters | Vector where default values of input parameters are stored.

Exceptions

  InvalidOperationException | When default values are not defined for all input parameters.

References IG.Num.InputElementDefinition.DefaultValue, IG.Num.InputElementDefinition.DefaultValueDefined, and IG.Num.VectorBase.Resize().

virtual void IG.Num.InputOutputDataDefiniton.GetInputBounds | ( | ref IBoundingBox | bounds | ) |
| inline virtual

Extracts input bounds as defined on the current data definition object, and stores them in the specified bounding box.

If some bounds are not defined then they are also not defined on the bounding box where bounds are stored.

After the call, bounding box will have bounds defined exacttly as they are set in the current input data definition.

Parameters

  bounds | Bounding box on which the extracted bounds are set.

References IG.Num.InputOutputElementDefinition.BoundsDefined, IG.Num.InputOutputElementDefinition.MaximalValue, and IG.Num.InputOutputElementDefinition.MinimalValue.

virtual void IG.Num.InputOutputDataDefiniton.GetOutputBounds | ( | ref IBoundingBox | bounds | ) |
| inline virtual

Extracts output bounds as defined on the current data definition object, and stores them in the specified bounding box.

If some bounds are not defined then they are also not defined on the bounding box where bounds are stored.

After the call, bounding box will have bounds defined exacttly as they are set in the current output data definition.

Parameters

  bounds | Bounding box on which the extracted bounds are set.

References IG.Num.InputOutputElementDefinition.BoundsDefined, IG.Num.InputOutputElementDefinition.MaximalValue, and IG.Num.InputOutputElementDefinition.MinimalValue.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyInputNameDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any input element has Name property defined.

References IG.Num.InputOutputElementDefinition.Name.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyOutputNameDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any output element has Name property defined.

References IG.Num.InputOutputElementDefinition.Name.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyNameDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any element (either input or output) has Name property defined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyInputTitleDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any input element has Title property defined.

References IG.Num.InputOutputElementDefinition.Title.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyOutputTitleDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any output element has Title property defined.

References IG.Num.InputOutputElementDefinition.Title.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyTitleDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any element (either input or output) has Title property defined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyInputDescriptionDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any input element has Description property defined.

References IG.Num.InputOutputElementDefinition.Description.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyOutputDescriptionDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any output element has Description property defined.

References IG.Num.InputOutputElementDefinition.Description.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyDescriptionDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any element (either input or output) has Description property defined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyInputDiscretizationStepDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any input element has DiscretizationStep property defined.

References IG.Num.InputElementDefinition.DiscretizationStep.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyOutputDiscretizationStepDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any output element has DiscretizationStep property defined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyDiscretizationStepDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any element (either input or output) has DiscretizationStep property defined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyInputBoundDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any input element has bounds defined.

References IG.Num.InputOutputElementDefinition.BoundsDefined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyOutputBoundDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any output element has bounds defined.

References IG.Num.InputOutputElementDefinition.BoundsDefined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyBoundDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any element (either input or output) has bounds defined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyInputScalingLengthDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any input element has scaling length defined.

References IG.Num.InputOutputElementDefinition.ScalingLengthDefined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyOutputScalingLengthDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any output element has scaling length defined.

References IG.Num.InputOutputElementDefinition.ScalingLengthDefined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyScalingLengthDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any element (either input or output) has scaling length defined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyInputTargetValueDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any input element has target value defined.

References IG.Num.InputOutputElementDefinition.TargetValueDefined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyOutputTargetValueDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any output element has target value defined.

References IG.Num.InputOutputElementDefinition.TargetValueDefined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyTargetValueDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any element (either input or output) has target value defined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyInputDefaultValueDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any input element has default value defined.

References IG.Num.InputElementDefinition.DefaultValueDefined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyOutputDefaultValueDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any output element has default value defined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyDefaultValueDefined | ( |  | ) |
| inline virtual

Returns a value indicating whether any element (either input or output) has default value defined.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyInputElementIndexSpecified | ( |  | ) |
| inline virtual

Returns a value indicating whether any input element has element index specified.

References IG.Num.InputOutputElementDefinition.ElementIndexSpecified.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyOutputElementIndexSpecified | ( |  | ) |
| inline virtual

Returns a value indicating whether any output element has element index specified.

References IG.Num.InputOutputElementDefinition.ElementIndexSpecified.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyElementIndexSpecified | ( |  | ) |
| inline virtual

Returns a value indicating whether any element (either input or output) has element index specified.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyInputOptimizationIndexSpecified | ( |  | ) |
| inline virtual

Returns a value indicating whether any input element has element index specified.

References IG.Num.InputElementDefinition.OptimizationIndexSpecified.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyOutputOptimizationIndexSpecified | ( |  | ) |
| inline virtual

Returns a value indicating whether any output element has element index specified.

virtual bool IG.Num.InputOutputDataDefiniton.IsAnyOptimizationIndexSpecified | ( |  | ) |
| inline virtual

Returns a value indicating whether any element (either input or output) has element index specified.

static void IG.Num.InputOutputDataDefiniton.SaveJson | ( | InputOutputDataDefiniton | dataDef,
|  | string | filePath
| ) |  |
| inline static

Saves input/output data definition to the specified JSON file. File is owerwritten if it exists.

Parameters

  dataDef | Object that is saved to a file.
  inputFilePath | Path to the file where training data is saved.

static void IG.Num.InputOutputDataDefiniton.LoadJson | ( | string | filePath,
|  | ref InputOutputDataDefiniton | dataDefRestored
| ) |  |
| inline static

Restores input/output data definition from the specified file in JSON format.

Parameters

  inputFilePath | File from which training data is restored.
  dataDefRestored | Narual networ approximator's definition data that is restored by deserialization.

Referenced by IG.Neural.DataMapperSimple.DataMapperSimple(), IG.Script.ScriptAppBase.DataStructuresFunctionTestCsvWriteDefinitionAndData(), IG.Neural.MappingApproximationFileManager.LoadDataDefinition(), and IG.Num.InputOutputDataDefiniton.SupplementDataDefinition().

static InputOutputDataDefiniton IG.Num.InputOutputDataDefiniton.CreateDefault | ( | int | inputLength,
|  | int | outputLength
| ) |  |
| inline static

Creates and returns a data definition with fields set to default values.

Parameters

  inputLength | Number of input elements.
  outputLength | Number of output elements.

References IG.Num.InputOutputDataDefiniton.AddInputElement(), and IG.Num.InputOutputDataDefiniton.AddOutputElement().

static void IG.Num.InputOutputDataDefiniton.SupplementDataDefinition | ( | InputOutputDataDefiniton | data,
|  | SampledDataSet | trainingData
| ) |  |
| inline static

Suplements the specified data definition object with information that is extracted from the training data set. Some data is updated independently of the training data set, and this data is updated even if the training data set is not specified. If bounds on input parameters and output values are not defined then bounds are set to bounds within which training data fits. If default values and target values are not specified then these values are set to centers of intervals. If names, titles and descriptions are not specified (null or empty string) then default strings are provided. If optimization parameter indices are not specified for input parameters then these indices are taken the same as elementindices. For fields that have the corresponding "...Defined" flag, data is recalculated only if that flag is set to false. In order to ensure recalculation of such fields, set the corresponding flags to false (for example, BoundsDefined for MinimalValue and MaximalValue, ScalingLengthDefined for ScalingLength, TargetValueDefined for TargetValue, etc.).

Parameters

  data | Definition data that is updated.
  trainingData | Training data that is used to calculate some values. If null then values which would be calculated form training data are not updated.

References IG.Num.InputOutputElementDefinition.BoundsDefined, IG.Num.InputElementDefinition.DefaultValue, IG.Num.InputElementDefinition.DefaultValueDefined, IG.Num.InputOutputElementDefinition.Description, IG.Num.InputOutputElementDefinition.ElementIndex, IG.Num.InputOutputElementDefinition.ElementIndexSpecified, IG.Num.InputOutputDataDefiniton.GetInputElement(), IG.Num.SampledDataSet.GetInputRange(), IG.Num.InputOutputDataDefiniton.GetOutputElement(), IG.Num.SampledDataSet.GetOutputRange(), IG.Num.InputOutputDataDefiniton.InputLength, IG.Num.InputOutputElementDefinition.IsInput, IG.Num.InputOutputElementDefinition.MaximalValue, IG.Num.InputOutputElementDefinition.MinimalValue, IG.Num.InputOutputElementDefinition.Name, IG.Num.InputElementDefinition.OptimizationIndex, IG.Num.InputElementDefinition.OptimizationIndexSpecified, IG.Num.InputOutputDataDefiniton.OutputLength, IG.Num.InputOutputElementDefinition.ScalingLength, IG.Num.InputOutputElementDefinition.ScalingLengthDefined, IG.Num.InputOutputElementDefinition.TargetValue, IG.Num.InputOutputElementDefinition.TargetValueDefined, and IG.Num.InputOutputElementDefinition.Title.

Referenced by IG.Neural.NeuralAllpicationCommands.CmdSupplementNeuralDataDefinition().

static void IG.Num.InputOutputDataDefiniton.SupplementDataDefinition | ( | string | dataDefinitionPath,
|  | string | trainingDataPath
| ) |  |
| inline static

Suplements the specified data definition object with information that is extracted from the training data set and with automatically generated information.

Parameters

  dataDefinitionPath | Path to the original data definition file. It can be unspecified, in this case the initial data definition object is created and initialized with some default values.
  trainingDataPath | Path to the training data. It can be unspecified, in this case training data is not used, and only the data that can have some default values is updated.

static void IG.Num.InputOutputDataDefiniton.SupplementDataDefinition | ( | string | dataDefinitionPath,
|  | string | trainingDataPath,
|  | string | updatedDataDefinitionPath
| ) |  |
| inline static

Suplements the specified data definition object with information that is extracted from the training data set and with automatically generated information.

Parameters

  dataDefinitionPath | Path to the original data definition file. It can be unspecified, in this case the initial data definition object is created and initialized with some default values.
  trainingDataPath | Path to the training data. It can be unspecified, in this case training data is not used, and only the data that can have some default values is updated.
  updatedDataDefinitionPath | Path where the updated data defiition is saved. It can be the same path as for the original file.

References IG.Num.SampledDataSet.LoadJson(), and IG.Num.InputOutputDataDefiniton.LoadJson().

static void IG.Num.InputOutputDataDefiniton.CopyPlain | ( | InputOutputDataDefiniton | original,
|  | InputOutputDataDefiniton | copy
| ) |  |
| inline static

Copies data from one data definition to another.

Parameters

  original | Source object that data is copied from.
  copy | Object to which data is copied.

Operation is performed only if both sorce and destination objects are non-null.

References IG.Num.InputOutputDataDefiniton.AddInputElement(), IG.Num.InputOutputDataDefiniton.AddOutputElement(), IG.Num.InputElementDefinition.Copy(), IG.Num.OutputElementDefinition.Copy(), IG.Num.InputOutputDataDefiniton.Description, IG.Num.InputOutputDataDefiniton.GetInputElement(), IG.Num.InputOutputDataDefiniton.GetOutputElement(), IG.Num.InputOutputDataDefiniton.InputElementList, IG.Num.InputOutputDataDefiniton.InputLength, IG.Num.InputOutputDataDefiniton.Name, IG.Num.InputOutputDataDefiniton.OutputElementList, and IG.Num.InputOutputDataDefiniton.OutputLength.

Referenced by IG.Num.InputOutputDataDefiniton.Copy().

static void IG.Num.InputOutputDataDefiniton.Copy | ( | InputOutputDataDefiniton | original,
|  | ref InputOutputDataDefiniton | copy
| ) |  |
| inline static

Copies data from one data definition to another.

Parameters

  original | Source object that data is copied from.
  copy | Object to which data is copied.

If original object is null then destination object is also set to null. If destination object is nul then it is allocated anew.

References IG.Num.InputOutputDataDefiniton.CopyPlain().

static InputOutputDataDefiniton IG.Num.InputOutputDataDefiniton.CreateExample | ( | int | inputLength,
|  | int | outputLength
| ) |  |
| inline static

Creates and returns an example data definition.

Parameters

  inputLength | Number of input elements.
  outputLength | Number of output elements.

References IG.Num.InputOutputDataDefiniton.AddInputElement(), and IG.Num.InputOutputDataDefiniton.AddOutputElement().

override string IG.Num.InputOutputDataDefiniton.ToString | ( |  | ) |
| inline

Returns string representation of the current object.

## Member Data Documentation

string IG.Num.InputOutputDataDefiniton.DefaultName = null
| static

Default value of the Name property of the input and output data definitions.

string IG.Num.InputOutputDataDefiniton.DefaultDescription = null
| static

Default value of the Description property of the input and output data definitions.

string IG.Num.InputOutputDataDefiniton._name = DefaultName
| protected

string IG.Num.InputOutputDataDefiniton._description = DefaultDescription
| protected

List<InputElementDefinition> IG.Num.InputOutputDataDefiniton._input = new List<InputElementDefinition>()
| protected

List<OutputElementDefinition> IG.Num.InputOutputDataDefiniton._output = new List<OutputElementDefinition>()
| protected

## Property Documentation

string IG.Num.InputOutputDataDefiniton.Name
| get set

Name of the current definition of input parameters and output values of a model.

Default value is specified by the static property InputOutputDataDefiniton.DefaultName.

Referenced by IG.Num.InputOutputDataDefinitonDto.CopyFromPlain(), and IG.Num.InputOutputDataDefiniton.CopyPlain().

string IG.Num.InputOutputDataDefiniton.Description
| get set

Description of the current definition of input parameters and output values of a model.

Default value is specified by the static property InputOutputDataDefiniton.DefaultDescription.

Referenced by IG.Num.InputOutputDataDefinitonDto.CopyFromPlain(), and IG.Num.InputOutputDataDefiniton.CopyPlain().

int IG.Num.InputOutputDataDefiniton.InputLength
| get

Gets number of input parameters.

Referenced by IG.Num.InputOutputDataDefinitonDto.CopyFromPlain(), IG.Num.InputOutputDataDefiniton.CopyPlain(), IG.Script.ScriptAppBase.DataStructuresFunctionTestCsvReadDefinitionAndData(), IG.Neural.NeuralTadej.SaveDefinitionDataCSV(), IG.Num.SampledDataSet.SaveDefinitionDataCSV(), and IG.Num.InputOutputDataDefiniton.SupplementDataDefinition().

int IG.Num.InputOutputDataDefiniton.OutputLength
| get

Gets number of output values.

Referenced by IG.Num.InputOutputDataDefinitonDto.CopyFromPlain(), IG.Num.InputOutputDataDefiniton.CopyPlain(), IG.Script.ScriptAppBase.DataStructuresFunctionTestCsvReadDefinitionAndData(), IG.Neural.NeuralTadej.SaveDefinitionDataCSV(), IG.Num.SampledDataSet.SaveDefinitionDataCSV(), and IG.Num.InputOutputDataDefiniton.SupplementDataDefinition().

virtual List<InputElementDefinition> IG.Num.InputOutputDataDefiniton.InputElementList
| get

Referenced by IG.Num.InputOutputDataDefinitonDto.CopyFromPlain(), and IG.Num.InputOutputDataDefiniton.CopyPlain().

virtual List<OutputElementDefinition> IG.Num.InputOutputDataDefiniton.OutputElementList
| get

Referenced by IG.Num.InputOutputDataDefinitonDto.CopyFromPlain(), and IG.Num.InputOutputDataDefiniton.CopyPlain().

The documentation for this class was generated from the following file:

- igbase/numeric/approximation/sampleddata/SampledDataDefinition.cs